<script setup lang="ts">
const props = defineProps<{
  selected: string | null;
  genes: string[];
}>();
const emit = defineEmits<{
  "update:selected": [value: string];
}>();

const { fetchByGenes } = useGOAnnotationService();
const { fetchByIds: fetchTermsByIds } = useOntologyService("GO");

const { data, pending, error } = await useAsyncData(
  `drosophila-go-annotations-${props.genes.join(",")}`,
  async () => {
    if (props.genes.length === 0) {
      return [];
    }
    const anns = await fetchByGenes(props.genes);
    const missingNames = new Set(
      anns.filter((a) => !a.term.name).map((a) => a.term.id),
    );
    if (missingNames.size > 0) {
      const terms = await fetchTermsByIds(Array.from(missingNames));
      const termMap = new Map(terms.map((t) => [t.id, t.name]));
      anns.forEach((a) => {
        if (!a.term.name) {
          a.term.name = termMap.get(a.term.id) || "";
        }
      });
    }
    return anns;
  },
);

const annotations = data.value || [];
const selectedAnnotations = computed(() => {
  return annotations.filter((a) => a.gene === props.selected);
});
</script>

<template>
  <v-select
    :model-value="selected"
    variant="outlined"
    density="compact"
    class="mb-2"
    :items="genes"
    style="max-width: 230px"
    label="Gene Ontology terms for"
    @update:model-value="(v: string) => emit('update:selected', v)"
  />
  <AsyncView
    :error="error"
    :loading="pending"
    :error-message="`Failed to fetch GO annotations for gene ${props.selected}`"
  >
    <GOAnnotationTabs :annotations="selectedAnnotations" dense />
  </AsyncView>
</template>
